<template>
    <div class="container">
        <div class="left-side">

            <div>
                <div>
                    <h1>Actions</h1>
                </div>
                <div><button class="btn" @click="clearLocalStorage">Clear local storage</button></div>
                <div><button class="btn" @click="showAddForm(null)">Add new student</button></div>
            </div>

            <div>
                <div>
                    <h1>Filters</h1>
                </div>

                <div><button class="btn" @click="clearFilters">Clear Filters</button></div>

                <div class="filter">
                    <label for="categoryFilter">Category</label>
                    <select id="categoryFilter" v-model="selectedCategory" @change="filterStudents">
                        <option value="">All Categories</option>
                        <option v-for="category in categories" :key="category">{{ category }}</option>
                    </select>
                </div>

                <div class="filter">
                    <label for="courseFilter">Course</label>
                    <select id="courseFilter" v-model="selectedCourse" @change="filterStudents">
                        <option value="">All Courses</option>
                        <option v-for="course in courses" :key="course">{{ course }}</option>
                    </select>
                </div>
            </div>
        </div>


        <div v-if="showAddStudentForm" class="add-container">
            <h1>{{ editingStudent ? 'Edit Student' : 'Add Student' }}</h1>
            <div>
                <label for="name">Name</label>
                <input type="text" id="name" name="name" v-model="student.name">
            </div>
            <div>
                <label for="surname">Surname</label>
                <input type="text" id="surname" name="surname" v-model="student.surname">
            </div>
            <div>
                <img :src="student.img" alt="No image" style="width: 20%;">
            </div>
            <div>
                <label for="imgSrc">Img URL</label>
                <input type="text" id="imgSrc" name="imgSrc" v-model="student.img">
            </div>
            <div>
                <label for="course">Course</label>
                <select id="course" name="course" v-model="student.course" required>
                    <option value="">Select a course</option>
                    <option v-for="course in courses" :key="course">{{ course }}</option>
                </select>
            </div>
            <div>
                <label for="category">Category</label>
                <select id="category" name="category" v-model="student.category" required>
                    <option value="">Select a category</option>
                    <option v-for="category in categories" :key="category">{{ category }}</option>
                </select>
            </div>
            <div>
                <button class="btn" @click="editingStudent ? updateStudent() : addStudent()">
                    {{ editingStudent ? 'Save' : 'Add' }}
                </button>
            </div>
            <div>
                <button class="btn" @click="cancelEditOrAdd">Cancel</button>
            </div>
        </div>



        <div class="list">
            <div>
                <h1>Students list</h1>
                <ul>
                    <li v-for="student in filteredStudents" :key="student.id" class="li">
                        <div class="userItem">
                            <div><img :src="student.img" alt="No image" class="img-st"></div>
                            <div style="margin-left: 10px;">
                                <a>{{ student.name }} {{ student.surname }}</a>
                            </div>
                        </div>
                        <div><button type="submit" class="btn" @click="showAddForm(student.id)">Edit</button></div>
                        <div class="li11">
                            <div class="li12">Course: {{ student.course }}</div>
                            <div class="li12">Category: {{ student.category }}</div>
                        </div>
                    </li>
                </ul>
            </div>
        </div>

    </div>
</template>

<script>
export default {
    name: 'StudentsPageC',
    data() {
        return {
            editingStudent: null,
            studentsData: [
                {
                    id: 1,
                    name: 'John',
                    surname: 'Doe',
                    img: 'https://image.shutterstock.com/image-photo/young-handsome-man-beard-wearing-260nw-1768126784.jpg',
                    course: 3,
                    category: 'great'
                },
                {
                    id: 2,
                    name: 'Jane',
                    surname: 'Smith',
                    img: 'https://images.unsplash.com/photo-1438761681033-6461ffad8d80?auto=format&fit=crop&q=80&w=1000&ixlib=rb-4.0.3&ixid=M3wxMjA3fDB8MHxzZWFyY2h8Mnx8cGVyc29ufGVufDB8fDB8fHww',
                    course: 2,
                    category: 'great'
                },
                {
                    id: 3,
                    name: 'Robert',
                    surname: 'Johnson',
                    img: 'https://media.istockphoto.com/id/877337294/photo/man-with-sunglasses-dancing-at-studio-shot.jpg?s=612x612&w=0&k=20&c=6u91YwJADmKYGk5wp2DC87InRgeabMXsh2QcHtM-HvM=',
                    course: 1,
                    category: 'bad'
                },
                {
                    id: 4,
                    name: 'Emily',
                    surname: 'Brown',
                    img: 'https://images.pexels.com/photos/1065084/pexels-photo-1065084.jpeg?cs=srgb&dl=pexels-hannah-nelson-1065084.jpg&fm=jpg',
                    course: 4,
                    category: 'great'
                },
                {
                    id: 5,
                    name: 'Michael',
                    surname: 'Wilson',
                    img: 'https://media.vanityfair.com/photos/6319eab06009e759e6638e28/master/w_2560%2Cc_limit/1421315651',
                    course: 2,
                    category: 'not set'
                },
                {
                    id: 6,
                    name: 'Sophia',
                    surname: 'Lee',
                    img: 'https://ccare.maclarenbaby.com/theme_scita/static/src/img/scita_demo_img/testimonial/team-5(1).jpg',
                    course: 3,
                    category: 'bad'
                },
                {
                    id: 7,
                    name: 'David',
                    surname: 'Martinez',
                    img: 'https://media.gq.com/photos/55a6a83f5f1c7af15a1f2c33/16:9/w_2560%2Cc_limit/GettyImages-480788326.jpg',
                    course: 4,
                    category: 'not set'
                }
            ],
            selectedCategory: '',
            selectedCourse: '',
            categories: ["great", "bad", "not set"],
            courses: [1, 2, 3, 4],
            student: {
                name: '',
                surname: '',
                img: '',
                course: '',
                category: '',
            },
            showAddStudentForm: false,
        }
    },
    computed: {
        // фільтрує студентів за допомогою обраної категорії та курсу
        filteredStudents() {
            return this.studentsData.filter(student => {
                const categoryFilter = !this.selectedCategory || student.category === this.selectedCategory;
                const courseFilter = !this.selectedCourse || student.course.toString() === this.selectedCourse;
                return categoryFilter && courseFilter;
            });
        },
    },
    methods: {
        //методи для збереження та завантаження із локал сторідж
        //01
        saveToLocalStorage() {
            localStorage.setItem('studentsData', JSON.stringify(this.studentsData));
        },
        //02
        loadFromLocalStorage() {
            const storedData = localStorage.getItem('studentsData');
            if (storedData) {
                this.studentsData = JSON.parse(storedData);
            }
        },
        //03
        clearLocalStorage() {
            localStorage.clear();
            window.location.reload();
        },

        //методи для роботи із даними студентів
        //1
        clearFilters() {
            this.selectedCategory = '';
            this.selectedCourse = '';
        },
        //2
        editStudent(studentId) {
            const existingStudent = this.studentsData.find((student) => student.id === studentId);
            if (existingStudent) {
                this.editingStudent = existingStudent.id;
                this.student = { ...existingStudent };
            }
        },
        //3
        updateStudent() {
            const existingStudentIndex = this.studentsData.findIndex(
                (student) => student.id === this.editingStudent
            );
            if (existingStudentIndex !== -1) {
                this.studentsData.splice(existingStudentIndex, 1, { ...this.student });
                this.saveToLocalStorage();
                this.student = {
                    name: '',
                    surname: '',
                    img: '',
                    course: '',
                    category: '',
                };
                this.editingStudent = null;
                this.showAddStudentForm = false;
            }
        },
        //4
        addStudent() {
            const newStudent = {
                id: this.studentsData.length + 1,
                name: this.student.name,
                surname: this.student.surname,
                img: this.student.img,
                course: this.student.course,
                category: this.student.category,
            };
            this.studentsData.push(newStudent);
            this.saveToLocalStorage();
            this.student = {
                name: '',
                surname: '',
                img: '',
                course: '',
                category: '',
            };
            this.showAddStudentForm = false;
        },
        //5
        showAddForm(studentId) {
            if (studentId !== null) {
                // Edit
                this.editStudent(studentId);
            } else {
                // Add
                this.addStudent();
            }
            this.editingStudent = studentId;
            this.showAddStudentForm = true;
        },
        //6
        cancelEditOrAdd() {
            this.showAddStudentForm = false;
        },
    },
    created() {
        // завантажує актуальні дані із локал сторідж
        this.loadFromLocalStorage();
    }
}
</script>

<style lang="css" scoped>
.container {
    display: flex;
    text-align: left;
    padding: 20px;
}

.list {
    padding: 20px;
}

.img-st {
    width: 150px;
    height: fit-content;
}

.left-side {
    display: flex;
    flex-direction: column;
    text-align: left;
    background-color: rgb(33, 53, 112);
    border-radius: 10px;
    padding: 20px;
    color: white;
}

.btn {
    cursor: pointer;
    background-color: rgba(255, 255, 255, 0.92);
    color: royalblue;
    padding: 8px 16px;
    border: none;
    border-radius: 5px;
    margin: 10px;
}

.filter {
    margin: 10px;
    display: flex;
    flex-direction: column;
    color: white;
    padding: 5px;
}

.add-container {
    display: flex;
    flex-direction: column;
    text-align: left;
    background-color: rgb(142, 169, 250);
    border-radius: 10px;
    padding: 20px;
}

.add-container div {
    margin: 3px;
}

.add-container div label {
    margin-right: 3px;
}

li {
    border: 5px solid #ccc;
    border-radius: 5px;
    padding: 20px;
    margin: 8px 0;
    display: flex;
    align-items: center;
    justify-content: space-between;
}

.li11 {
    display: flex;
    justify-content: space-between;
    align-items: center;
}

.li12 {
    margin: 10px
}
</style>